function obj = CLARI_NON_B(H,N,Neq)

obj.H=H;          % harmonic number
obj.N=N;          % mode number 
obj.Neq = Neq;    %equations number
obj.zeta=0.2;     % calibration parameter
obj.wr=2*pi*1050; % resonance of the 
obj.qr=0.01;      % qr anche
obj.c=340;        % speed sound
obj.lt=5.6e-8;    % thermic boundary layer thickness
obj.lv = 4e-8;    % viscous boundary layer thickness
obj.Cpv=1.4;      % Cpv
obj.r=7e-3;       % radius, cylindrical resonator
obj.L=0.2201;     % length, cylindrical resonator

obj.w=2*pi*obj.c/(4*obj.L)*[1:2:2*N-1]';    % omega,  cylindrical resonator (N)
obj.alpha=(obj.w/(obj.c)).^0.5*(sqrt(obj.lv)+(obj.Cpv-1)*sqrt(obj.lt))/obj.r; % alpha, cylindrical resonator (N)


sys = SYS(Neq*(2*H+1)+2);

obj = class(obj,'CLARI_NON_B',sys);