function [] = disp(obj,U,Ujstab)

% Affichage des exposants de Floquet

omega = U(end,:);
ALP=Ujstab(2:5)';
T=2*pi./omega;
RHO=exp(ALP.*T);
disp(['Floquet exponents real part: ',num2str(real(ALP))])
disp(['Floquet multiplier moduli: ',num2str(abs(RHO))])
disp(['Floquet multiplier: ',num2str(RHO)])

H=obj.H;
Neq=obj.Neq;
figure(5)
clf
h1=subplot(2,1,1);
plotbarHBM(H,Neq,U,[1 2],h1);
h2=subplot(2,1,2);
plotperiodHBM(H,Neq,U,[1 2],h2);

% NRJ calculation

figure(6)
tt=0:0.001:1;
UU=calcperiodHBM(tt,obj.H,obj.Neq,U,[3 4 5 6]);
v1=UU(1,:);
v2=UU(2,:);
N1=UU(3,:);
N2=UU(4,:);

k1=1;k2=2;
h=0.5*(v1.^2+v2.^2)+0.5*(N1.^2/k1+N2.^2/k2);
plot(tt,h,'r')
err=(max(h)-min(h))/mean(h)*100;
disp(['Energy conservation error: ',num2str(err),'%'])
disp(['lambda = ',num2str(U(end-1))])

% return

%%%Reconstruction du cycle limite
% H=obj.H;
% Neq=obj.Neq;
T=2*pi/U(end);
temps=0:T/100:T;

VectCos=zeros(H,length(temps));
VectSin=zeros(H,length(temps));
for j=1:H,
VectCos(j,:) = cos(j*U(end)*temps);
VectSin(j,:) = sin(j*U(end)*temps);
end;


cycle_u1= U(1) + U(Neq+1:2*Neq:(2*H-1)*Neq+1)'*VectCos + U(2*Neq+1:2*Neq:(2*H)*Neq+1)'*VectSin;
cycle_u2= U(2) + U(Neq+2:2*Neq:(2*H-1)*Neq+2)'*VectCos + U(2*Neq+2:2*Neq:(2*H)*Neq+2)'*VectSin;
cycle_v1= U(3) + U(Neq+3:2*Neq:(2*H-1)*Neq+3)'*VectCos + U(2*Neq+3:2*Neq:(2*H)*Neq+3)'*VectSin;
cycle_v2= U(4) + U(Neq+4:2*Neq:(2*H-1)*Neq+4)'*VectCos + U(2*Neq+4:2*Neq:(2*H)*Neq+4)'*VectSin;
cycle_N1= U(5) + U(Neq+5:2*Neq:(2*H-1)*Neq+5)'*VectCos + U(2*Neq+5:2*Neq:(2*H)*Neq+5)'*VectSin;
cycle_N2= U(6) + U(Neq+6:2*Neq:(2*H-1)*Neq+6)'*VectCos + U(2*Neq+6:2*Neq:(2*H)*Neq+6)'*VectSin;



% Comparaison with direct intergration
% X0 initial condition ; T period
X0=[ cycle_u1(1) cycle_u2(1) cycle_v1(1) cycle_v2(1)];
[temps_ode X] =ode45(@ressort,[0 T],X0); ;


hh=figure(3);%set(hh,'Position',[1,1,1000,800]);
subplot(2,1,1)
plot(temps,cycle_u1,'b',temps,cycle_u2,'r',temps_ode,X(:,1),'.b',temps_ode,X(:,2),'.r');
title(['Time evolution of u_1 and u_2 with ' num2str(H) ' harmonics'],'Fontsize',16)
xlabel('time (s)'):ylabel('u_1');legend(['u1'],['u2'],['u1(ODE45)'],['u2(ODE45)'],'Location','SouthEast');grid on;

subplot(2,1,2);
plot(cycle_u1,cycle_u2,'b',X(:,1),X(:,2),'.b');
title(['Trajectory in the configuration space (u1,u2)'], 'FontSize',16);
xlabel('u1'):ylabel('u2');legend(['HBM'],['Num. Int. with ODE45'],'Location','SouthEast');grid on;axis equal


%plot(cycle_u,cycle_v,'b',cycle_u_ode(:,1),cycle_u_ode(:,2),'r');
%title(['Attractor in the phase space (u,v=u'')'], 'FontSize',16);
%xlabel('u'):ylabel('v=u''');legend(['Solution with ' num2str(H) ' harmonics'],['Solution from time domain ODE-solver'],'Location','SouthEast');grid on;


