!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Fichier d'équations pour MANLAB avec équilibrage harmonique!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!   Two perpendicular springs in a plane
! 
!   Sami Karkar, April 2010


module petits_operateurs

    implicit none
    real(8), parameter :: eps=1.0d-16, pi=3.1415926535897931d0

! ajouter ici les constantes du problème que vous souhaiter utiliser
! dans l'ensemble des fonctions définies ci-dessous

    integer(4), parameter :: Neq=6, nbddl=4
    real(8), parameter :: k1=1d0, k2=2d0, m=1d0

contains

function pC0()

    real(8) pC0(Neq)

! entrer ici les valeurs de l'opérateur 'c0'

    pC0=0.0d0

end function pC0

function pC1()

    real(8) pC1(Neq)

! entrer ici les valeurs de l'opérateur 'c1'

    pC1=0.0d0
    
end function pC1

function pL0(pu)

    real(8), intent(IN) ::  pu(Neq)
    real(8) pL0(Neq)


! entrer ici les valeurs de l'opérateur 'l0'
! en fonction du vecteur pu

    pL0(1)= pu(3)
    pL0(2)= pu(4)
    pL0(3)=-pu(5)
    pL0(4)=-pu(6)
    pL0(5)= pu(5) - k1*pu(1)
    pL0(6)= pu(6) - k2*pu(2)


end function pL0

function pL1(pu)
    
    real(8), intent(IN) ::  pu(Neq)
    real(8) pL1(Neq)

! entrer ici les valeurs du petit operateur 'l1'
! en fonction du vecteur  pu

    pL1=0d0
    pL1(3)=-pu(3)/m
    pL1(4)=-pu(4)/m

   
end function pL1

function pQ(pu,pv)
    
    real(8), intent(IN) ::  pu(Neq), pv(Neq)
    real(8)  pQ(Neq)

! entrer ici les valeurs du petit operateur 'q'
! en fonction des vecteurs  pu et pv

    pQ(1:2)=0.0d0
    pQ(3)=-pu(1)*(pv(5)+pv(6))
    pQ(4)=-pu(2)*(pv(5)+pv(6))
    pQ(5)=-k1/2D0*(pu(1)*pv(1) + pu(2)*pv(2))
    pQ(6)=-k2/2D0*(pu(1)*pv(1) + pu(2)*pv(2))

   
end function pQ
    
function pM(pu)
    
    real(8), intent(IN) :: pu(Neq)
    real(8) pM(Neq)

! entrer ici les valeurs du petit operateur 'm'
! en fonction du vecteur  pu

    pM(1)=pu(1)
    pM(2)=pu(2)
    pM(3)=pu(3)
    pM(4)=pu(4)
    pM(5:6)=0.0d0

    
end function pM

end module petits_operateurs
