!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!     File 'jacobien.f90'  for MANLAB using HBM              !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     Forced Duffing Oscillator  : Jacobian matrices J0, JL and JQ
!
!     S. Karkar
!     Oct 2010
!



module jacobien

    use petits_operateurs
    implicit none

    contains
        function J0(lambda,omega)
            real(8), intent(in) :: lambda, omega
            complex(8) J0(nbddl,nbddl)
            J0=0d0
            J0=reshape([0d0, -w0**2, 1d0, -mu],[2,2])
        end function J0

        function JL(lambda,omega,Ustab)
            real(8), intent(in) :: lambda, omega
            complex(8), intent(in) :: Ustab(nbddl)
            complex(8) JL(nbddl,nbddl)
            JL=0D0
!            JL(2,1) = -3*gamm*Ustab(1)
        end function JL

        function JQ(lambda,omega,Ustab,Vstab)
            real(8), intent(in) :: lambda, omega
            complex(8), intent(in) :: Ustab(nbddl), Vstab(nbddl)
            complex(8) JQ(nbddl,nbddl)
            JQ=0d0
            JQ(2,1) = -3*gamm*Ustab(1)*Vstab(1)
        end function JQ

end module jacobien
