function [] = disp(obj,U,Ustab)

figure(3)
clf
h1=subplot(2,1,1);
H=plotbarHBM(obj.H,obj.Neq,U,[1],h1);
h2=subplot(2,1,2);
Hand=plotperiodHBM(obj.H,obj.Neq,U,[1],h2);

omega = U(end,:);
ALP=Ustab(2:3)';
T=2*pi./omega;
RHO=exp(ALP.*T);
disp(['Floquet exponents real part: ',num2str(real(ALP))])
disp(['Floquet multiplier moduli: ',num2str(abs(RHO))])

% NRJ calculation

figure(4)
tt=0:0.001:1;
UU=calcperiodHBM(tt,obj.H,obj.Neq,U,[1 2]);
u=UU(1,:);
v=UU(2,:);
ome0=obj.ome0;     
Gamma=obj.Gamma;

h=0.5*v.^2+0.5*ome0^2*u.^2+Gamma/4*u.^4;
plot(tt,h)
err=(max(h)-min(h))/mean(h)*100;
plot(tt,h,'r')
xlabel('Dimensionless time t/T')
ylabel('Energy')
title(['Energy conservation error: ',num2str(err),'%'])

disp(['Energy conservation error: ',num2str(err),'%'])
disp(['lambda = ',num2str(U(end-1))])

