function [] = disp(obj,U,Ustab)

% Bargraph, time evolution and mode display
% ===============================================================

figure(3)
h1=subplot(2,1,1);
cla
plotbarHBM(obj.H,obj.Neq,U,[1 2],h1);
h2=subplot(2,2,3);
cla
plotperiodHBM(obj.H,obj.Neq,U,[1 2],h2);
h3=subplot(2,2,4);
cla
tt=0:0.01:1;
UU=calcperiodHBM(tt,obj.H,obj.Neq,U,[1 2]);
u1=UU(1,:);
u2=UU(2,:);
plot(u1,u2,'linewidth',1)
xlabel('u_1')
ylabel('u_2')

return

% Bargraphs and time evolution for convergence check
% ===============================================================

figure(4)
clf
h1=subplot(2,1,1);
H=plotbarHBM(obj.H,obj.Neq,U,[1 2],h1);
h2=subplot(2,1,2);
Hand=plotperiodHBM(obj.H,obj.Neq,U,[1 2],h2);

% NRJ calculation and plot
% ===============================================================

figure(5)
tt=0:0.001:1;
UU=calcperiodHBM(tt,obj.H,obj.Neq,U,[1 2 3 4]);
u1=UU(1,:);
u2=UU(2,:);
v1=UU(3,:);
v2=UU(4,:);

h=0.5*(v1.^2+v2.^2)+0.5*(u1.^2+u2.^2+(u1-u2).^2)+1/8*u1.^4;
plot(tt,h)
err=(max(h)-min(h))/mean(h)*100;
disp(['Energy conservation error: ',num2str(err),'%'])

if size(Ustab,1)>1
  omega = U(end,:);
  ALP=Ustab(2:5)';
  T=2*pi./omega;
  RHO=exp(ALP.*T);
  disp(['Floquet multiplier moduli: ',num2str(abs(RHO))])
end
