% Solution echelles multiples de:
%
% ddq1 + 2 mu1 dq1 + omega1^2 q1 + alpha1 q1q2 
% ddq2 + 2 mu2 dq2 + omega2^2 q2 + alpha2 q1^2 = F2 cos Omega t
%
% omega2 = 2 omega1 + sigma1
% Omega = omega2 + sigma2
% Sigma2 = sigmin:pas:sigmax
%
% Om_omega2(3.55,-4,4,.01,1,.1,.1,16, 7, 4);
% Om_omega2(1,-1,1,.001,0,.1,.1,2, 1, 1);

%%
%Om_omega2(1,-1,1,.001,0,.1,.1,1, 1, 1);
%Om_omega2(1,-1,1,.001,0,.1,.1,2, 1, 1);
%
% [Sigma2,A2st,A2inst,A2C,A1Cst,A1Cinst]=Om_omega2(omega1,sigmin,sigmax,pas,sigma1,mu1,mu2,F2,alpha1, alpha2);

function [Sigma2,A2st,A2inst,A2C,A1Cst,A1Cinst]=Om_omega2(omega1,sigmin,sigmax,pas,sigma1,mu1,mu2,F2,alpha1, alpha2)

Sigma2 = sigmin:pas:sigmax; 
omega2 = 2*omega1+sigma1;

Gamma1 =(2*omega1*omega2)/(alpha1*alpha2)*(2*mu1*mu2 - Sigma2.*(sigma1+Sigma2)); 
Gamma2 =(2*omega1*omega2)/(alpha1*alpha2)*(2*mu1*Sigma2 + mu2*(sigma1+Sigma2));
A2=F2/2/omega2./sqrt(Sigma2.^2+mu2.^2);
A2C=2*omega1/alpha1*sqrt((sigma1+Sigma2).^2+4*mu1^2);
A1Cinst = 2*sqrt(-Gamma1 - sqrt( F2^2/alpha2^2/4 - Gamma2.^2)); 
A1Cst = 2*sqrt(-Gamma1 + sqrt( F2^2/alpha2^2/4 - Gamma2.^2)); 

% Elimination des "ailes" des courbes couplees, qui sont complexes
I=find(imag(A1Cst)~=0);
A1Cst(I)=NaN*ones(size(I));
A1Cinst(I)=NaN*ones(size(I));
A2C(I)=NaN*ones(size(I));
% Elimination de la partie centrale de A1Cinst,  partie reelle
% nulle et partie imaginaire non-nulle
I=find(imag(A1Cinst)~=0);
A1Cinst(I(2:end-1))=NaN*ones(size(I(2:end-1))); % On garde
                                                % nanmoins les
                                                % deux points
                                                % extrmes  partie
                                                % relle nulle,
                                                % pour que ce soit
                                                % plus joli
A1Cinst=real(A1Cinst);

% Dtection de la partie de A2 qui est instable
I=find(A2-A2C>0);
A2inst=NaN*ones(size(A2));
A2st=A2;
A2st(I)=NaN*ones(size(I));
A2inst(I)=A2(I);

figure(11)
clf
hold on
plot(Sigma2,A2st,'b','linewidth',1)
plot(Sigma2,A2inst,'b:','linewidth',1)
plot(Sigma2,A2C,'b','linewidth',1)
plot(Sigma2,A1Cst,'r','linewidth',1)
plot(Sigma2,A1Cinst,'r:','linewidth',1)
xlabel('sigma2')

return

%%



I=0;


for ii=1:length(Sigma2)
    sigma2 =Sigma2(ii);
    
    Gamma1 = (2*omega1*omega2) / (alpha1*alpha2) * (2*mu1*mu2 - sigma2*(sigma1 + sigma2));
    Gamma2 = (2*omega1*omega2) /(alpha1*alpha2)* (2*mu1*sigma2 - mu2*(sigma1+sigma2));

   
    
%------------------------------------
    A21 = (2*omega1 / alpha1)*( (sigma1+sigma2)^2 + 4*mu1^2)^(1/2);
    a21(:,ii) = A21;
      
    A22 = f2/(2*omega2*(sigma2^2 + mu2^2)^(1/2));
    a22(:,ii) = A22;   
%------------------------------------     
    A11 = 2*(-Gamma1 - ( (1/4)*(f2^2/alpha2^2) - Gamma2^2)^(1/2))^(1/2); % +/-
    a11(:,ii) = A11;
     
    A12 = 2*(-Gamma1 + ( (1/4)*(f2^2/alpha2^2) - Gamma2^2)^(1/2))^(1/2); % +/-
    a12(:,ii) = A12;
%------------------------------------
    
        if imag(A11)==0
                I11 = 1;
        else 
                I11 = 0;
        end
        
        if imag(A12)==0
                I12 = 1;
        else
                I12 = 0;
        end
         
        %I11=find(imag(A11)==0)
        %I12=find(imag(A12)==0)
        I= I11+I12;
        
        if I==2
             a1(1,ii) = A11;
             a1(2,ii) = A12;
        end
            
        if I==1    
            if I11==1
            a1(1,ii) = A11;
            a1(2,ii) = NaN;
                   
            else %I12==1
             a1(2,ii) = A12;
             a1(1,ii) = NaN;
            end

        end

        if I==0
            a1(1,ii) = NaN;
            a1(2,ii) = NaN;
            
        end   
end

a2(1,:) = a21;
a2(2,:) = a22;
f = Sigma2;

%%
 figure(12)
 subplot (2,1,1)
 plot (Sigma2, a1(1,:),Sigma2, a1(2,:))
 title('a1')
 
 %figure(2)
 subplot (2,1,2)
 plot( Sigma2, a21, Sigma2, a22)
 title('a2')
  
 
 figure(13)
 subplot 211
 plot (Sigma2, a11,':', Sigma2, a12, ':', Sigma2, a21,':', Sigma2, a22,':')
 subplot 212
 plot (Sigma2, imag(a11),':', Sigma2,imag(a12), ':', Sigma2, imag(a21),':', Sigma2 ,imag(a22),':')







