function [Ups,FpnlA] = calculeseries(sys,Uo,Utj)


% Starting point tangent matrix of the system
dRdU = get_dRdU(sys,Uo);

% Tangent vector at starting point
U1 = tangente(sys,dRdU,Uo);


if (U1'*Utj) <0
  U1 = - U1;
end


% Tangent matrix for ANM
K = [dRdU ; (get_chemin(sys).*U1)'];

% Fast LU-factorization
[LK,UK,pK,qK] = lu(K,'vector');

[neq, ninc] = size(dRdU);

pmax = get_ordre(sys);

Ups = zeros(ninc,pmax+1);

%% 
% Starting point
% 

Ups(:,1) = Uo;

%%                 
% First Order   
%                 

Ups(:,2) = U1;

%%  
% Next Orders 
%                 

for p=2:pmax

    Fpnl = zeros(ninc,1);  
      
    for r=1:p-1
      Fpnl = Fpnl - [ Q(sys,Ups(:,r+1),Ups(:,p-r+1)) ; 0 ] ;
    end


% Use LU-factors for inversion of K
    Ups(qK,p+1) = UK\(LK\Fpnl(pK)) ;

% At this point, for p=2 we shall have Ups = [U0, U1, U2]

end


% Additional rhs member
   FpnlA = zeros(neq,1);  
      
    for r=1:p
      FpnlA = FpnlA - Q(sys,Ups(:,r+1),Ups(:,p+2-r));
    end

% sign of det(K) (will change through a bifurcation)
disp(['branch sign : ',num2str(sign(prod(diag(UK))))]);


