function Ut = tangente(sys,dRdU,Uj)
% Utj is built from tangent matrix dRdU
% Uj is unused, except function overload

ninc = length(dRdU(1,:));
b = sparse(ninc,1,1,ninc,1);

% Tangent matrix
Tmat = [dRdU ; sparse(sys.randvect) ];
% Fast LU-factorization
[LT,UT,pT,qT] = lu(Tmat,'vector');

% Efficient LU-inversion
Ut(qT,1) = -  UT\(LT\b(pT));

% Normalization according to pseduo arc-length equation :
% a=(U-Uo)*U1 + (l-lo)*l1
Ut = Ut *  1/sqrt((sys.chemin.*Ut)'*Ut );
