function varargout = manlab(varargin)
% MANLAB M-file for manlab.fig
%      MANLAB, by itself, creates a new MANLAB or raises the existing
%      singleton*.
%
%      H = MANLAB returns the handle to a new MANLAB or the handle to
%      the existing singleton*.
%
%      MANLAB('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MANLAB.M with the given input arguments.
%
%      MANLAB('Property','Value',...) creates a new MANLAB or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before manlab_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to manlab_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help manlab

% Last Modified by GUIDE v2.5 17-Dec-2010 20:56:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @manlab_OpeningFcn, ...
                   'gui_OutputFcn',  @manlab_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before manlab is made visible.
function manlab_OpeningFcn(hObject, eventdata, handles, varargin)
for i=get(0,'Children')'
    if i~= handles.figure1
        clf(i)
    end
end % clear all figures

global ML_first_correction_onoff;
global ML_pointdisplay;
global ML_globaldisplay;
global ML_analyse_series;
global ML_stability;
global ML_algostab;
global ML_tolstab;

% Choose default command line output for manlab
handles.output = hObject;

% SYS OBJECT
handles.sys = varargin{1};

% PARAMETERS
params.cfp = 1e-6;        % Perturbation amplitude
params.pertsign = 0;      % Perturbation sign (+1/0/-1)
params.endstepcorron = 0; % ANM-end-step correction (on/off)
params.pointdisplay = ML_pointdisplay; % Current point display (on/off)
params.globaldisplay = ML_globaldisplay; % Customised diagram display (on/off)
params.analyse_series = ML_analyse_series; % Series analysis (on/off)
params.stability = ML_stability; % Stability analysis (on/off)
params.algostab = ML_algostab; % Select algo to use for stability analysis (1:time, 2:freq)
params.tolstab = ML_tolstab; % Tolerance on Floquet multipliers norm (default : 1e-4)
handles.params = params;

% DIAGRAM
diaginfos.uaxis = [0 1 0 1];
diaginfos.bloquervue = 0;
diaginfos.perturbation = 0;
diaginfos.drawtype = '-';
diaginfos.dispcolors = ['b','r','g','c','m','y','k','b','r','g','c','m','y','k','b'];
diaginfos.dispvars = varargin{3};
diaginfos.courbeactive = 1;

% Stability analysis : setup
if handles.params.stability ==  1
    diaginfos.stabvars = varargin{4};
    diaginfos.drawstab = ':';
    HH = diaginfos.stabvars(end);
    if HH == 0;
        diaginfos.nbddlstab = length(diaginfos.stabvars) - 2;
    else
        diaginfos.nbddlstab = length(diaginfos.stabvars) - 3; 
    end
    if handles.params.algostab == 1
        diaginfos.nbddl = get_nbddlT(handles.sys, diaginfos.nbddlstab+1);
        handles.Ujstab = zeros(diaginfos.nbddl + 1,1);
    else
        diaginfos.nbddl = get_nbddlF(handles.sys, diaginfos.nbddlstab+1);
        handles.Ujstab = zeros(1+diaginfos.nbddl*(2*HH+1),1);
    end
else
    diaginfos.stabvars = [];
    diaginfos.drawstab = '-';
    diaginfos.nbddl=0;
    diaginfos.nbddlstab=0;
end
%


handles.diaginfos = diaginfos;
handles.diagram = DIAGRAM(diaginfos);

% STARTING POINT AND TANGENT
handles.Uj = varargin{2};

if (length(handles.Uj(1,:)) > 1)
  errordlg('Vector ML_Ustart has a wrong size. Note that it must be a column vector.','Wrong ML_Ustart size','on');
end

if ML_first_correction_onoff==1
	handles.Uj = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
end
handles.dRdU = get_dRdU(handles.sys,handles.Uj) ;
handles.Utj = tangente(handles.sys,handles.dRdU,handles.Uj );
afficher_carres(hObject, handles);

handles.Ujold =  handles.Uj;
handles.Utjold =  handles.Utj;

% CREATE EMPTY BRANCH (initialise the class)
handles.branche_courrante = BRANCHE(handles.sys, handles.Uj, handles.Utj, 0, handles.diaginfos, handles.params);

% CREATE EMPTY PORTION (initialise the class)
troncon_init = TRONCON(handles.sys, handles.Uj, handles.Utj, handles.diaginfos, handles.params, 0);

% Sets checkboxes and menus on/off
set(handles.checkbox4,'Value',handles.params.pointdisplay);
set(handles.checkbox5,'Value',handles.params.globaldisplay);
set(handles.checkbox6,'Value',handles.params.stability);

if handles.params.stability ==1
    set(handles.stabalgo_menu,'Enable','on');
    set(handles.checkbox6,'Enable','on');
    if handles.params.algostab ==1
        set(handles.T_algo,'Checked','on');
        set(handles.F_algo,'Checked','off');
    else
        set(handles.F_algo,'Checked','on');
        set(handles.T_algo,'Checked','off');
    end
else
    set(handles.stabalgo_menu,'Enable','off');
    set(handles.checkbox6,'Enable','off');
end

set(handles.radiobutton2,'Value',1);
set(handles.radiobutton1,'Value',0);
set(handles.radiobutton3,'Value',0);

set(handles.bloquervuecheck,'Value',0);
set(handles.corractive,'Value',0);

set(handles.seuilcorr,'String',num2str(get_seuilcorr(handles.sys)));
set(handles.seuilman,'String',num2str(get_seuil(handles.sys)));
set(handles.nbtroncons,'String','5');
set(handles.cfpstr,'String',num2str(handles.params.cfp));

% DISPLAY if handles.params.pointdisplay = 1
if handles.params.pointdisplay ==  1
    if handles.params.stability ==  1
        disp(handles.sys,handles.Uj,handles.Ujstab);
    else
        disp(handles.sys,handles.Uj,1);
    end
end


% ENREGISTREMENT DES DONNEES
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function mlh = manlab_OutputFcn(hObject, eventdata, handles)

mlh.hobject = hObject;
mlh.handles = handles;




function branchep_Callback(hObject, eventdata, handles)

nbtroncons = str2double(get(handles.nbtroncons,'String'));

handles.Utjold = handles.Utj;
handles.Ujold = handles.Uj;

afficher_diagramme(hObject, handles, 0);
handles.branche_courrante = BRANCHE(handles.sys, handles.Uj, handles.Utj, nbtroncons, handles.diaginfos,handles.params );
[handles.Uj,handles.Utj] = point_oriente_sortie(handles.branche_courrante,get_seuil(handles.sys));

if handles.params.stability ==  1
    handles.Ujstab = get_Ujstab(handles.branche_courrante);
end

handles.branche_courrante = set_drawtype(handles.branche_courrante, handles.diaginfos.drawtype);

handles.diagram = push_branch(handles.diagram, handles.branche_courrante);
afficher_carres(hObject, handles);
handles.diaginfos.uaxis = axis;
guidata(hObject,handles);
disp('Branch computed.');

function branchem_Callback(hObject, eventdata, handles)

nbtroncons = str2double(get(handles.nbtroncons,'String'));

handles.Utjold = handles.Utj;
handles.Ujold = handles.Uj;

afficher_diagramme(hObject, handles, 0);
handles.branche_courrante = BRANCHE(handles.sys, handles.Uj, -handles.Utj, nbtroncons, handles.diaginfos,handles.params);
[handles.Uj,handles.Utj] = point_oriente_sortie(handles.branche_courrante,get_seuil(handles.sys));

if handles.params.stability ==  1
    handles.Ujstab = get_Ujstab(handles.branche_courrante);
end

handles.branche_courrante = set_drawtype(handles.branche_courrante, handles.diaginfos.drawtype);

handles.diagram = push_branch(handles.diagram, handles.branche_courrante);
afficher_carres(hObject, handles);
handles.diaginfos.uaxis = axis;
guidata(hObject,handles);
disp('Branch computed.');

% --- Executes during object creation, after setting all properties.
function nbtroncons_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function nbtroncons_Callback(hObject, eventdata, handles)
disp('Number of steps per branch updated.');

% --- Executes on button press in recpoint.
function recpoint_Callback(hObject, eventdata, handles)

figure(2);
[handles.Uj,handles.Utj,handles.Ujstab,idxbranche,idxtroncon,Afound,handles.courbeactive,diaginfos] = get_pointstab(handles.diagram,handles.diaginfos.nbddl);
handles.diaginfos.dispcolors=diaginfos.dispcolors;
handles.diaginfos.dispvars=diaginfos.dispvars;
handles.diaginfos.perturbation=diaginfos.perturbation;
handles.diaginfos.drawtype=diaginfos.drawtype;

afficher_diagramme(hObject, handles, 1);

if handles.params.pointdisplay==1
        disp(handles.sys,handles.Uj,handles.Ujstab); drawnow;
end

mutual_exclude([handles.radiobutton1,handles.radiobutton2,handles.radiobutton3]);
if handles.diaginfos.perturbation > 0
    set(handles.radiobutton1,'Value',1);
elseif handles.diaginfos.perturbation == 0
    set(handles.radiobutton2,'Value',1);
elseif handles.diaginfos.perturbation < 0
    set(handles.radiobutton3,'Value',1);
end

guidata(hObject,handles);

function cfpstr_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function cfpstr_Callback(hObject, eventdata, handles)

handles.params.cfp =  str2double(get(handles.cfpstr,'String'));

handles.sys = set_pert(handles.sys,handles.params.pertsign * handles.params.cfp);
disp('Perturbation amplitude updated. Looking for a branch...');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
guidata(hObject,handles);

function seuilman_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function seuilman_Callback(hObject, eventdata, handles)
seuilman =  str2double(get(handles.seuilman,'String'));
handles.sys = set_seuil(handles.sys,seuilman);
guidata(hObject,handles);
disp('ANM threshold updated.');

function seuilcorr_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function seuilcorr_Callback(hObject, eventdata, handles)
seuilcorr =  str2double(get(handles.seuilcorr,'String'));
handles.sys = set_seuilcorr(handles.sys,seuilcorr);
disp('Correction threshold updated.');
if (norm(get_R(handles.sys,handles.Uj))>seuilcorr)
    disp('Looking for the branch...');
    [handles.Uj] = correction(handles.sys, seuilcorr, get_itemax(handles.sys), handles.Uj);
end
afficher_carres(hObject, handles);
afficher_diagramme(hObject, handles, 1);
guidata(hObject,handles);

function radiobutton1_Callback(hObject, eventdata, handles)
mutual_exclude([handles.radiobutton2,handles.radiobutton3]);
handles.params.pertsign = 1;
handles.sys = set_pert(handles.sys,handles.params.cfp);
handles.diaginfos.perturbation = get_pert(handles.sys);
disp('Positive perturbation selected. Looking for the branch...');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
handles.diaginfos.drawtype = '-.';
guidata(hObject,handles);

function radiobutton2_Callback(hObject, eventdata, handles)
mutual_exclude([handles.radiobutton1,handles.radiobutton3]);
handles.params.pertsign = 0;
handles.sys = set_pert(handles.sys,0);
handles.diaginfos.perturbation = get_pert(handles.sys);
disp('Null perturbation selected. Looking for the branch...');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
handles.diaginfos.drawtype = '-';
guidata(hObject,handles);


function radiobutton3_Callback(hObject, eventdata, handles)
mutual_exclude([handles.radiobutton1,handles.radiobutton2]);
handles.params.pertsign = -1;
handles.sys = set_pert(handles.sys,-handles.params.cfp);
handles.diaginfos.perturbation = get_pert(handles.sys);
disp('Negative perturbation selected. Looking for the branch...');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
handles.diaginfos.drawtype = '-.';
guidata(hObject,handles);

function mutual_exclude(off)
set(off,'Value',0)


function load_Callback(hObject, eventdata, handles)

[file,path] = uigetfile;
loadeddatas = load('-mat',[path file],'diagram') ;
sizetest=size(get_Ups(get_troncon(get_branche(loadeddatas.diagram,1),1))); correctsize=[size(handles.Uj,1),get_ordre(handles.sys)+1];
if (sizetest(1)~=correctsize(1) || sizetest(2)~=correctsize(2))
    errordlg(['You launched Manlab with ninc=' int2str(correctsize(1)) ', p=' int2str(correctsize(2)-1) '                                             ' ...
    'You''re trying to load a diagram with ninc=' int2str(sizetest(1)) ', p=' int2str(sizetest(2)-1)], ...
    'ERROR : wrong system size or different ANM series order' );
else
    handles.diagram = loadeddatas.diagram;
    afficher_diagramme(hObject, handles, 1);
end

guidata(hObject,handles);


function save_Callback(hObject, eventdata, handles)

[file,path] = uiputfile;
diagram = handles.diagram;
save([path file], 'diagram') ;

guidata(hObject,handles);


function voirpoint_Callback(hObject, eventdata, handles)

figure(2);

[handles.Uj,handles.Utj,handles.Ujstab,idxbranche,idxtroncon,Afound,handles.courbeactive,diaginfos] = get_pointstab(handles.diagram,handles.diaginfos.nbddl);
handles.diaginfos.dispcolors=diaginfos.dispcolors;
handles.diaginfos.dispvars=diaginfos.dispvars;
handles.diaginfos.perturbation=diaginfos.perturbation;
handles.diaginfos.drawtype=diaginfos.drawtype;

afficher_diagramme(hObject, handles, 1);

disp(handles.sys,handles.Uj,handles.Ujstab);
drawnow;

mutual_exclude([handles.radiobutton1,handles.radiobutton2,handles.radiobutton3]);
if handles.diaginfos.perturbation > 0
    set(handles.radiobutton1,'Value',1);
elseif handles.diaginfos.perturbation == 0
    set(handles.radiobutton2,'Value',1);
elseif handles.diaginfos.perturbation < 0
    set(handles.radiobutton3,'Value',1);
end

guidata(hObject,handles);


function effacertroncon_Callback(hObject, eventdata, handles)
figure(2);
handles.diagram = delete_troncon(handles.diagram);

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);


function effacerbranche_Callback(hObject, eventdata, handles)
figure(2);
handles.diagram = delete_branche(handles.diagram);

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);

function bloquervuecheck_Callback(hObject, eventdata, handles)

if (get(hObject,'Value') == get(hObject,'Max'))
  disp('Zoom locked');
  handles.diaginfos.bloquervue = 1;
  if ishandle(2); set(0,'CurrentFigure',2); else; figure(2); end;   handles.diaginfos.uaxis = axis ;
else
  disp('Zoom unlocked');
  handles.diaginfos.bloquervue = 0;
  if ishandle(2); set(0,'CurrentFigure',2); else; figure(2); end;   axis auto ; handles.diaginfos.uaxis = axis ;  
end

guidata(hObject,handles);



function importeruj_Callback(hObject, eventdata, handles)

global ML_Uj;


if length(ML_Uj)~=get_ninc(handles.sys)
  disp('ERROR : Variable ML_Uj not defined or wrong size.');
else
disp('External variable ML_Uj imported.');

disp('Looking for the branch...');

[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), ML_Uj);
handles.Utj = tangente(handles.sys,get_dRdU(handles.sys,handles.Uj),handles.Uj);
afficher_diagramme(hObject, handles,1);

guidata(hObject,handles);
end



function afficher_diagramme(hObject, handles, tracer_carres)
if ishandle(2); set(0,'CurrentFigure',2); else; figure(2); end;
handles.diaginfos.uaxis = axis ;clf; disp(handles.diagram);

if handles.diaginfos.bloquervue == 1
  axis (handles.diaginfos.uaxis);
else
  axis auto;
end

guidata(hObject,handles);
if tracer_carres ==1
  afficher_carres(hObject, handles);
end

function afficher_carres(hObject, handles)
if ishandle(2); set(0,'CurrentFigure',2); else; figure(2); end; 
% Pour chaque courbes
hold on ;
%fxhandle = get_fxhandle(handles.sys);
%fyhandle = get_fyhandle(handles.sys);
%x = feval(fxhandle,handles.sys,handles.Uj(idxX));
%y = feval(fyhandle,handles.sys,handles.Uj(idxY));
%petits carres
for i=1:length(handles.diaginfos.dispvars(:,1))
idxX = handles.diaginfos.dispvars(i,1);
idxY = handles.diaginfos.dispvars(i,2);
plot(handles.Uj(idxX),handles.Uj(idxY),'sk');
end
% petites fleches
s = axis;

lxe = abs(s(2)-s(1));
lye = abs(s(4)-s(3));


for i=1:length(handles.diaginfos.dispvars(:,1))
 idxX = handles.diaginfos.dispvars(i,1);
 idxY = handles.diaginfos.dispvars(i,2);
 utx = handles.Utj(idxX);
 uty = handles.Utj(idxY);
 lt = sqrt((utx/lxe)^2+(uty/lye)^2)*15;
 utx = utx/lt;
 uty = uty/lt;

 plot([handles.Uj(idxX), handles.Uj(idxX)+utx],[handles.Uj(idxY), handles.Uj(idxY)+uty],'k');
%quiver(handles.Uj(idxX),handles.Uj(idxY),utx*l,uty*l,'k');
end
hold off


function Saut_Callback(hObject, eventdata, handles )

disp('Select desired location to jump to. /!\ Use the first coordinate of the plot only /!\');
figure(2); [x,y] = ginput(1);


Uj=handles.Uj;

%handles.Utj = tangente(handles.sys,get_dRdU(handles.sys,handles.Uj),handles.Uj);

Utj = handles.Utj;

k = handles.diaginfos.courbeactive;


idx = handles.diaginfos.dispvars(k,1);
idy = handles.diaginfos.dispvars(k,2);

% Normalisation de la tangente VISIBLE !
Utj = Utj/sqrt((Utj(idx)^2+Utj(idy)^2));

xdep = Uj(idx);
ydep = Uj(idy);


% On calcule la longueur du saut
longueur = sqrt((x-xdep)^2+(y-ydep)^2);

% On calcule le produit scalaire pour determiner le sens
scal = (x-xdep)*Utj(idx) + (y-ydep)*Utj(idy);

if scal < 0
  Utj = -Utj;
end


% On effectue le saut
Uj = Uj + longueur * Utj;

disp('Looking for the branch...');
% On effectue la correction

[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), Uj);
handles.Utj = tangente(handles.sys,get_dRdU(handles.sys,handles.Uj),handles.Uj);
afficher_diagramme(hObject, handles,1);

guidata(hObject,handles);


function variables_Callback(hObject, eventdata, handles)


dispvars = handles.diaginfos.dispvars;

nbmaxd = 8;
prompt = {'x1,y1','x2,y2','x3,y3','x4,y4','x5,y5','x6,y6','x7,y7','x8,y8'};
def =    {'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0'};

for i=1:length(dispvars(:,1));
  def{i} = [num2str(dispvars(i,1)) ',' num2str(dispvars(i,2))];
end

rep = inputdlg(prompt,'Titre',1,def);

dispvars = [];
for i=1:nbmaxd
  a = sscanf(rep{i},'%i,%i');
  if (a(1) <=0)
    break;
  end
  
  dispvars(i,1) = a(1);
  dispvars(i,2) = a(2);
end

handles.diaginfos.dispvars = dispvars;


handles.diagram = evalue(handles.diagram, get_nbptstroncon(handles.sys), ...
       handles.diaginfos);

afficher_diagramme(hObject, handles,1);
guidata(hObject,handles);


function exporteruj_Callback(hObject, eventdata, handles)

global ML_Uj ML_Ujstab ML_Utj

ML_Uj = handles.Uj;
ML_Utj = handles.Utj;
disp(['Point exported in global variable ML_Uj, tangent in ML_Utj']);
if handles.params.stability == 1
    ML_Ujstab = handles.Ujstab;
    disp(['Stability infos can be found in ML_Ujstab.']);
else
    ML_Ujstab = 1;
end


function effacerdiagramme_Callback(hObject, eventdata, handles)

if ishandle(2); set(0,'CurrentFigure',2); else; figure(2); end; 
handles.diagram = delete_allbranches(handles.diagram);

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);


function effacerderbranche_Callback(hObject, eventdata, handles)


if ishandle(2); set(0,'CurrentFigure',2); else; figure(2); end; 
handles.diagram = delete_lastbranche(handles.diagram);

handles.Utj = handles.Utjold;
handles.Uj = handles.Ujold;

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);
disp('Latest computed branch cancelled.');

function visualisertroncon_Callback(hObject, eventdata, handles)
disp('Select portion to display.');
figure(2);

[idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
troncon = get_troncon(handles.diagram, idxbranch, idxtroncon);
Us = get_Us(troncon,get_seuilman(troncon),get_nbptstroncon(handles.sys));
for i=get(0,'Children')'; if (i~=2 && i~=handles.figure1); clf(i); end; end; % clear the user defined figures
if query_stabinfos(get_branche(handles.diagram, idxbranch))
    disp_global(handles.sys,Us,get_Ustab(troncon));
else
    disp_global(handles.sys,Us,[ones(1,size(Us,2)) ; zeros(handles.diaginfos.nbddl,size(Us,2))]);
end

function visualiserbranche_Callback(hObject, eventdata, handles)
disp('Select branch to display.');
figure(2);
 [idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
branche = get_branche(handles.diagram, idxbranch);
Us = get_Us(branche,get_nbptstroncon(handles.sys));
for i=get(0,'Children')'; if (i~=2 && i~=handles.figure1); clf(i); end; end; % clear the user defined figures
if query_stabinfos(branche)
    disp_global(handles.sys,Us,get_Ustab(branche));
else
    disp_global(handles.sys,Us,[ones(1,size(Us,2)) ; zeros(handles.diaginfos.nbddl,size(Us,2))]);
end

function visualiserdiagramme_Callback(hObject, eventdata, handles)
disp('Displaying diagram.');
branches = get_branches(handles.diagram);

for i=get(0,'Children')'; if (i~=2 && i~=handles.figure1); clf(i); end; end; % clear the user defined figures
for i = 1:length(branches)
  disp([num2str(i) '/' num2str(length(branches))]);
  Us = get_Us(branches{i},get_nbptstroncon(handles.sys));
  if query_stabinfos(branches{i})
      disp_global(handles.sys,Us,get_Ustab(branches{i}));
  else
      disp_global(handles.sys,Us,[ones(1,size(Us,2)) ; zeros(handles.diaginfos.nbddl,size(Us,2))]);
  end
end  


function exportertroncon_Callback(hObject, eventdata, handles)
figure(2);
disp('Select portion to export.');
[idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
troncon = get_troncon(handles.diagram, idxbranch, idxtroncon);
branche = get_branche(handles.diagram, idxbranch);

global ML_Ut ML_Ups ML_Utstab
ML_Ut = get_Us(troncon,get_seuilman(troncon),get_nbptstroncon(handles.sys));
ML_Ups = get_Ups(troncon);
disp('Portion exported in global variable ML_Ut');
disp('Corresponding series can be found in global variable ML_Ups');
if query_stabinfos(branche)
    ML_Utstab = get_Ustab(troncon);
    disp('Stability infos can be found in ML_Utstab');
else
    ML_Utstab = ones(1,size(ML_Ut,2));
end

function exporterbranche_Callback(hObject, eventdata, handles)
disp('Select branch to export');
figure(2);
 [idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
branche = get_branche(handles.diagram, idxbranch);

global ML_Ub ML_Ubstab
ML_Ub = get_Us(branche,get_nbptstroncon(handles.sys));
disp('Branch exported in global variable ML_Ub');
if query_stabinfos(branche)
    ML_Ubstab = get_Ustab(branche);
    disp('Stability infos can be found in ML_Ubstab');
else
    ML_Ubstab = ones(1,size(ML_Ub,2));
end

function exporterdiagramme_Callback(hObject, eventdata, handles)
global ML_Ud ML_Udstab
nbptstroncon = get_nbptstroncon(handles.sys);
ML_Ud = get_Us(handles.diagram,nbptstroncon);
disp('Diagram exported in global variable ML_Ud');
if handles.params.stability==1
    ML_Udstab = get_Ustab(handles.diagram,nbptstroncon,handles.diaginfos.nbddl);
    disp('Stability infos can be found in ML_Udstab');
else
    ML_Udstab = ones(1,size(ML_Ud,2));
end




function corractive_Callback(hObject, eventdata, handles)

if (get(hObject,'Value') == 1)
  disp('End-step correction enabled');
  handles.params.endstepcorron = 1;
else
  disp('End-step correction disabled');
  handles.params.endstepcorron = 0;
end

guidata(hObject,handles);


function checkbox4_Callback(hObject, eventdata, handles)

if (get(hObject,'Value') == 1)
  disp('Current point display enabled.');
  handles.params.pointdisplay = 1;
else
  disp('Current point display disabled.');
  handles.params.pointdisplay = 0;
end

guidata(hObject,handles);

function checkbox5_Callback(hObject, eventdata, handles)

if (get(hObject,'Value') == 1)
  disp('Global display enabled.');
  handles.params.globaldisplay = 1;
else
  disp('Global display disabled.');
  handles.params.globaldisplay = 0;
end

guidata(hObject,handles);


% --- Executes on button press in checkbox6.
function checkbox6_Callback(hObject, eventdata, handles)

if (get(hObject,'Value') == 1)
      disp('Stability analysis enabled.');
      handles.params.stability = 1;
      set(handles.stabalgo_menu,'Enable','on');
else
  disp('Stability analysis disabled.');
  handles.params.stability = 0;
  set(handles.stabalgo_menu,'Enable','off');
end

guidata(hObject,handles);


% --------------------------------------------------------------------
function F_algo_Callback(hObject, eventdata, handles)
% hObject    handle to F_algo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if strcmp(get(hObject, 'Checked'),'off')
    set(hObject,'Checked','on');
    handles.params.algostab=0;
    set(handles.T_algo,'Checked','off');
    disp('Stability analysis performed using Hill''s method.')
end
guidata(hObject,handles);

% --------------------------------------------------------------------
function T_algo_Callback(hObject, eventdata, handles)
% hObject    handle to T_algo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if strcmp(get(hObject,'Checked'),'off')
    set(hObject,'Checked','on');
    handles.params.algostab=1;
    set(handles.F_algo,'Checked','off');
    disp('Stability analysis performed using time integration algorithm.');
end
guidata(hObject,handles);

% --------------
function stabalgo_menu_Callback(hObject, eventdata, handles)

function properties_menu_Callback(hObject, eventdata, handles)

function figure1_CreateFcn(hObject, eventdata, handles)
scrsz=get(0,'ScreenSize');
figpos=get(hObject,'Position');
set(hObject,'Position',[ scrsz(3)-figpos(3)+1 scrsz(4)-figpos(4)+1 figpos(3:4)]);
guidata(hObject,handles);

% --------------------------------------------------------------------
function quit_menu_Callback(hObject, eventdata, handles)
confirm=  questdlg('Are you sure you want to close Manlab ?','Close Manlab ?','Yes','No','No');
if strcmp(confirm,'Yes')
    for i=get(0,'Children')'
        if i~=handles.figure1
            clf(i);
        end
    end
    delete(handles.figure1);
end
